//---------------------------------------------------------------------------

#pragma hdrstop
#include <stdio.h>
#include "..\Lib\Dongle_API.h"
//---------------------------------------------------------------------------

#pragma argsused
int main(int argc, char* argv[])
{
	DWORD dwRet = 0;	
	int nCount = 0;
	int i = 0;
	char AdminPin [] = "FFFFFFFFFFFFFFFF";//ĬϿPIN
	int nRemainCount = 0;
	
	DONGLE_HANDLE hDongle = NULL;
	RSA_PUBLIC_KEY  rsaPub;
	RSA_PRIVATE_KEY rsaPri;
	PRIKEY_FILE_ATTR priAttr;
	WORD wPriID = 0x1111;

	FILE *fp = NULL;
	int nLen = 0;
	BYTE buffer[128];
	BYTE tmpbuf[128];
	int  nInDataLen = 0;
	int  nOutDataLen = 0;
	
	for(i = 0; i < 128; i++) buffer[i] = i;

	//ö
	dwRet = Dongle_Enum(NULL, &nCount);
	printf("Enum %d Rockey ARM. \n", nCount);
	
	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Rockey ARM. Return : 0x%08X . \n", dwRet);

	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);

	//RSA˽Կ
	priAttr.m_Size = 1024;//Ҳ2048
	priAttr.m_Type = FILE_PRIKEY_RSA;
	priAttr.m_Lic.m_Count =0xFFFFFFFF;//ɵô
	priAttr.m_Lic.m_IsDecOnRAM = FALSE;//ǷΪڴеݼ
	priAttr.m_Lic.m_IsReset = FALSE;//Ƿָ̬
	priAttr.m_Lic.m_Priv = 0;//ɵõСȨ

	dwRet = Dongle_CreateFile(hDongle, FILE_PRIKEY_RSA, wPriID, (void*)&priAttr);
	printf("Create RSA private key file. Return: 0x%08X\n", dwRet);
	if (DONGLE_SUCCESS != dwRet)
	{
		return 0;
	}

	//RSA˽Կ
	dwRet = Dongle_RsaGenPubPriKey(hDongle, wPriID, &rsaPub, &rsaPri);
	printf("Gen RSA Public key and private key. Return: 0x%08X\n", dwRet);
	if (DONGLE_SUCCESS != dwRet)
	{
		return 0;
	}

	//ݹ˽Կ
	fp = fopen("1111.Rsapub", "wb");
	fwrite(&rsaPub, 1, sizeof(RSA_PUBLIC_KEY), fp);
	fclose(fp);

	fp = fopen("1111.Rsapri", "wb");
	fwrite(&rsaPri, 1, sizeof(RSA_PRIVATE_KEY), fp);
	fclose(fp);
	fp = NULL;


	//RSA˽ԿܹԿ
	//1.RSA˽Կ
	nInDataLen = (128 -11);
	nOutDataLen = 128;
	memcpy(tmpbuf, buffer, nInDataLen);
	dwRet = Dongle_RsaPri(hDongle, wPriID, FLAG_ENCODE, buffer, nInDataLen, buffer, &nOutDataLen);
	printf("RSA private key encode. Return: 0x%08X\n", dwRet);

	//2.RSAԿ
	nInDataLen = 128;
	nOutDataLen = (128-11);
	dwRet = Dongle_RsaPub(hDongle, FLAG_DECODE, &rsaPub, buffer, nInDataLen, buffer, &nOutDataLen);
	printf("RSA public key decode. Return: 0x%08X\n", dwRet);

	if (memcmp(tmpbuf, buffer, 117) == 0)
		printf("the private encode and public decode result is right. \n");
	else 
		printf("the private encode and public decode result is wrong. \n");

	printf("\n");

	//RSAԿ˽Կ
	//1.RSAԿ
	for (i = 0 ; i < 128; i++) buffer[i] = i;
	nInDataLen  = (128-11);
	nOutDataLen = 128;
	memcpy(tmpbuf, buffer, nInDataLen);
	dwRet = Dongle_RsaPub(hDongle, FLAG_ENCODE, &rsaPub, buffer, nInDataLen, buffer, &nOutDataLen);
	printf("RSA public key encode. Return: 0x%08X\n", dwRet);

	//2.RSA˽Կ
	nInDataLen  = 128;
	nOutDataLen = (128 -11);
	dwRet = Dongle_RsaPri(hDongle, wPriID, FLAG_DECODE, buffer, nInDataLen, buffer, &nOutDataLen);
	printf("RSA private key decode. Return: 0x%08X\n", dwRet);	

	if (memcmp(tmpbuf, buffer, 117) == 0)
		printf("the public encode and private decode result is right. \n");
	else 
		printf("the public encode and private decode result is wrong. \n");

	//ɾ˽Կ
	dwRet = Dongle_DeleteFile(hDongle, FILE_PRIKEY_RSA, wPriID);
	printf("Delete RSA private key file. Return: 0x%08X\n", dwRet);

	//رռ
	dwRet = Dongle_Close(hDongle);
	printf("Close Rockey ARM. Return: 0x%08X\n", dwRet);

	return 0;
}
//---------------------------------------------------------------------------
