//---------------------------------------------------------------------------

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
#include <stdio.h>
#include "..\Lib\Dongle_API.h"
int main(int argc, char* argv[])
{
	DWORD dwRet = 0;	
	int nCount = 0;
	int i = 0;
	char AdminPin [] = "FFFFFFFFFFFFFFFF";//ĬϿPIN
	int nRemainCount = 0;
	
	DONGLE_HANDLE hDongle = NULL;
	ECCSM2_PUBLIC_KEY  sm2Pub; //ECCԿSM2Կṹͬ
	ECCSM2_PRIVATE_KEY sm2Pri; //ECC˽ԿSM2˽Կṹͬ
	PRIKEY_FILE_ATTR priAttr;
	WORD wPriID = 0x2222;
	
	FILE *fp = NULL;
	int nLen = 0;
	BYTE pSign[64]; //ǩݹ̶64ֽ
	BYTE pHash[24]; //192λĲ24ֽڣ256λĲ32ֽ
	int  nHashData = 24;
	
	for (i = 0; i < 24; i++) pHash[i] = i;
	
	//ö
	dwRet = Dongle_Enum(NULL, &nCount);
	printf("Enum %d Rockey ARM. \n", nCount);
	
	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Rockey ARM. Return : 0x%08X . \n", dwRet);
	
	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);
	
	//ECC˽Կ
	priAttr.m_Size = 0x8100;//˴ע⣬SM2˽Կ̶Ϊֵ
	priAttr.m_Type = FILE_PRIKEY_RSA;
	priAttr.m_Lic.m_Count =0xFFFFFFFF;//ɵô
	priAttr.m_Lic.m_IsDecOnRAM = FALSE;//ǷΪڴеݼ
	priAttr.m_Lic.m_IsReset = FALSE;//Ƿָ̬
	priAttr.m_Lic.m_Priv = 0;//ɵõСȨ
	
	dwRet = Dongle_CreateFile(hDongle, FILE_PRIKEY_ECCSM2, wPriID, (void*)&priAttr);
	printf("Create SM2 private key file. Return: 0x%08X\n", dwRet);
	if (DONGLE_SUCCESS != dwRet)
	{
		return 0;
	}
	
	//SM2˽Կ
	dwRet = Dongle_SM2GenPubPriKey(hDongle, wPriID, &sm2Pub, &sm2Pri);
	printf("Gen SM2 Public key and private key. Return: 0x%08X\n", dwRet);
	if (DONGLE_SUCCESS != dwRet)
	{
		return 0;
	}
	
	//SM2˽Կ
	fp = fopen("2222.EccSm2pub", "wb");
	fwrite(&sm2Pub, 1, sizeof(ECCSM2_PUBLIC_KEY), fp);
	fclose(fp);
	
	fp = fopen("2222.EccSm2pri", "wb");
	fwrite(&sm2Pri, 1, sizeof(ECCSM2_PRIVATE_KEY), fp);
	fclose(fp);
	fp = NULL;
	
	//ECC˽Կǩ
	dwRet = Dongle_SM2Sign(hDongle, wPriID, pHash, nHashData, pSign);
	printf("SM2 private key sign. Return: 0x%08X\n", dwRet);
	
	
	//ECCԿǩ
	dwRet = Dongle_SM2Verify(hDongle, &sm2Pub, pHash, nHashData, pSign);
	if (DONGLE_SUCCESS == dwRet)
	{
		printf("SM2 public key verify success. \n");
	}
	else
	{
		printf("SM2 public key verify failed. \n");
	}
	
	//ɾESM2˽Կ
	dwRet = Dongle_DeleteFile(hDongle, FILE_PRIKEY_ECCSM2, wPriID);
	printf("Delete SM2 private key file. Return: 0x%08X\n", dwRet);
	
	//رռ
	dwRet = Dongle_Close(hDongle);
	printf("Close Rockey ARM. Return: 0x%08X\n", dwRet);

	return 0;
}
//---------------------------------------------------------------------------
