//---------------------------------------------------------------------------

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
#include <stdio.h>
#include "..\Lib\Dongle_API.h"
int main(int argc, char* argv[])
{
	DWORD dwRet = 0;	
	int nCount = 0;
	int i = 0;
	char AdminPin [] = "FFFFFFFFFFFFFFFF";//ĬϿPIN
	int nRemainCount = 0;
	
	DONGLE_HANDLE hDongle = NULL;
	WORD wKeyID = 0x3333;
	KEY_FILE_ATTR keyAttr;
	
	BYTE buffer[1024]; 
	BYTE tmpbuf[1024]; 
	BYTE key[16] ;
	
	for (i = 0; i < 1024; i++) buffer[i] = i;
	
	//ö
	dwRet = Dongle_Enum(NULL, &nCount);
	printf("Enum %d Rockey ARM. \n", nCount);
	
	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Rockey ARM. Return : 0x%08X . \n", dwRet);

	//ȡһ16ֽڵΪԿ
	dwRet = Dongle_GenRandom(hDongle, 16, key);
	printf("Gen Random. Return: 0x%08X\n", dwRet);
	if (DONGLE_SUCCESS == dwRet)
	{
		printf("Random Data: ");
		for (i = 0; i < 16; i++)
		{
			printf("%02X ", key[i]);
		}
		printf("\n");
	}

	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);
	
	//3DES/SM4Կ	
	keyAttr.m_Size = 16;//Կݳȹ̶Ϊ16
	keyAttr.m_Lic.m_Priv_Enc = 0;//СɼȨ
	
	dwRet = Dongle_CreateFile(hDongle, FILE_KEY, wKeyID, (void*)&keyAttr);
	printf("Create 3DES/SM4 key file. Return: 0x%08X\n", dwRet);
	if (DONGLE_SUCCESS != dwRet)
	{
		return 0;
	}

	dwRet = Dongle_WriteFile(hDongle, FILE_KEY, wKeyID, 0, key, 16);
	printf("Write 3DES/SM4 key file. Return: 0x%08X\n", dwRet);

	printf("\n3DES Encode and Decode...\n");
	//3DES
	memcpy(tmpbuf, buffer, 1024);
	dwRet = Dongle_TDES(hDongle, wKeyID, FLAG_ENCODE, buffer, buffer, 1024);
	printf("3DES encode. Return: 0x%08X\n", dwRet);


	//3DES
	dwRet = Dongle_TDES(hDongle, wKeyID, FLAG_DECODE, buffer, buffer, 1024);
	printf("3DES decode. Return: 0x%08X\n", dwRet);
	
	if (memcmp(tmpbuf, buffer, 1024) == 0) 
		printf("3DES decode result is right. \n");
	else 
		printf("3DES decode result is wrong. \n");
	

	printf("\nSM4 Encode and Decode...\n");
	//SM4
	memcpy(tmpbuf, buffer, 1024);
	dwRet = Dongle_SM4(hDongle, wKeyID, FLAG_ENCODE, buffer, buffer, 1024);
	printf("SM4 encode. Return: 0x%08X\n", dwRet);
	
	
	//SM4
	dwRet = Dongle_SM4(hDongle, wKeyID, FLAG_DECODE, buffer, buffer, 1024);
	printf("SM4 decode. Return: 0x%08X\n", dwRet);
	
	if (memcmp(tmpbuf, buffer, 1024) == 0) 
		printf("SM4 decode result is right. \n");
	else 
		printf("SM4 decode result is wrong. \n");

	//ɾԿ
	dwRet = Dongle_DeleteFile(hDongle, FILE_KEY, wKeyID);
	printf("Delete 3DES/SM4 key file. Return: 0x%08X\n", dwRet);
	
	//رռ
	dwRet = Dongle_Close(hDongle);
	printf("Close Rockey ARM. Return: 0x%08X\n", dwRet);

	return 0;
}
//---------------------------------------------------------------------------
